<?php
/**
 * InlineResponse20039ContentItemsAllOf
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20039ContentItemsAllOf Class Doc Comment
 *
 * @category Class
 * @description Object containing informations about timestamps grouped by employee and days: * a list of timestamp objects * infos about the single \&quot;periods\&quot; of timestamps * the working time model of the employee for the given day
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20039ContentItemsAllOf implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_39_contentItems_allOf';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'employeeId' => 'int',
        'date' => '\DateTime',
        'weekDay' => 'string',
        'workingTimeModelId' => 'int',
        'timestamps' => 'object[]',
        'types' => 'array<string,\SLIS\Adapter\Tanss\Model\InlineResponse20039ContentItemsAllOfTypesAddlProps>'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'employeeId' => null,
        'date' => 'date',
        'weekDay' => null,
        'workingTimeModelId' => null,
        'timestamps' => null,
        'types' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'employeeId' => 'employeeId',
        'date' => 'date',
        'weekDay' => 'weekDay',
        'workingTimeModelId' => 'workingTimeModelId',
        'timestamps' => 'timestamps',
        'types' => 'types'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'employeeId' => 'setEmployeeId',
        'date' => 'setDate',
        'weekDay' => 'setWeekDay',
        'workingTimeModelId' => 'setWorkingTimeModelId',
        'timestamps' => 'setTimestamps',
        'types' => 'setTypes'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'employeeId' => 'getEmployeeId',
        'date' => 'getDate',
        'weekDay' => 'getWeekDay',
        'workingTimeModelId' => 'getWorkingTimeModelId',
        'timestamps' => 'getTimestamps',
        'types' => 'getTypes'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const WEEK_DAY_MONDAY = 'MONDAY';
    public const WEEK_DAY_TUESDAY = 'TUESDAY';
    public const WEEK_DAY_WEDNESDAY = 'WEDNESDAY';
    public const WEEK_DAY_THRUSDAY = 'THRUSDAY';
    public const WEEK_DAY_FRIDAY = 'FRIDAY';
    public const WEEK_DAY_SATURDAY = 'SATURDAY';
    public const WEEK_DAY_SUNDAY = 'SUNDAY';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getWeekDayAllowableValues()
    {
        return [
            self::WEEK_DAY_MONDAY,
            self::WEEK_DAY_TUESDAY,
            self::WEEK_DAY_WEDNESDAY,
            self::WEEK_DAY_THRUSDAY,
            self::WEEK_DAY_FRIDAY,
            self::WEEK_DAY_SATURDAY,
            self::WEEK_DAY_SUNDAY,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['weekDay'] = $data['weekDay'] ?? null;
        $this->container['workingTimeModelId'] = $data['workingTimeModelId'] ?? null;
        $this->container['timestamps'] = $data['timestamps'] ?? null;
        $this->container['types'] = $data['types'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getWeekDayAllowableValues();
        if (!is_null($this->container['weekDay']) && !in_array($this->container['weekDay'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'weekDay', must be one of '%s'",
                $this->container['weekDay'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of the employee
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return \DateTime|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param \DateTime|null $date day in the format YYYY-mm-dd
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets weekDay
     *
     * @return string|null
     */
    public function getWeekDay()
    {
        return $this->container['weekDay'];
    }

    /**
     * Sets weekDay
     *
     * @param string|null $weekDay Enum representing a weekday
     *
     * @return self
     */
    public function setWeekDay($weekDay)
    {
        $allowedValues = $this->getWeekDayAllowableValues();
        if (!is_null($weekDay) && !in_array($weekDay, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'weekDay', must be one of '%s'",
                    $weekDay,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['weekDay'] = $weekDay;

        return $this;
    }

    /**
     * Gets workingTimeModelId
     *
     * @return int|null
     */
    public function getWorkingTimeModelId()
    {
        return $this->container['workingTimeModelId'];
    }

    /**
     * Sets workingTimeModelId
     *
     * @param int|null $workingTimeModelId id of the working time model. Infos are stored in the \"list properties\" - \"workingTimeModels\" - (ID) - \"extras\" - \"model\"
     *
     * @return self
     */
    public function setWorkingTimeModelId($workingTimeModelId)
    {
        $this->container['workingTimeModelId'] = $workingTimeModelId;

        return $this;
    }

    /**
     * Gets timestamps
     *
     * @return object[]|null
     */
    public function getTimestamps()
    {
        return $this->container['timestamps'];
    }

    /**
     * Sets timestamps
     *
     * @param object[]|null $timestamps A list of all timestamps of the given day
     *
     * @return self
     */
    public function setTimestamps($timestamps)
    {
        $this->container['timestamps'] = $timestamps;

        return $this;
    }

    /**
     * Gets types
     *
     * @return array<string,\SLIS\Adapter\Tanss\Model\InlineResponse20039ContentItemsAllOfTypesAddlProps>|null
     */
    public function getTypes()
    {
        return $this->container['types'];
    }

    /**
     * Sets types
     *
     * @param array<string,\SLIS\Adapter\Tanss\Model\InlineResponse20039ContentItemsAllOfTypesAddlProps>|null $types a list of timestamp periods, grouped by the timestamp type. The key is the TimestampType, the value is a list of TimestampPeriods
     *
     * @return self
     */
    public function setTypes($types)
    {
        $this->container['types'] = $types;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


